Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.ode
Class FirstOrderConverter

    java.lang.Object
      org.apache.commons.math.ode.FirstOrderConverter

All Implemented Interfaces:
  FirstOrderDifferentialEquations

    public class FirstOrderConverter

extends Object
implements FirstOrderDifferentialEquations

This class converts second order differential equations to first order ones.

This class is a wrapper around a `SecondOrderDifferentialEquations` which allow to use a `FirstOrderIntegrator` to integrate it.

The transformation is done by changing the n dimension state vector to a 2n dimension vector, where the first n components are the initial state variables and the n last components are their first time derivative. The first time derivative of this state vector then really contains both the first and second time derivative of the initial state vector, which can be handled by the underlying second order equations set.

One should be aware that the data is duplicated during the transformation process and that for each call to `computeDerivatives`, this wrapper does copy 4n scalars : 2n before the call to `computeSecondDerivatives` in order to dispatch the y state vector into z and zDot, and 2n after the call to gather zDot and zDDot into yDot. Since the underlying problem by itself perhaps also needs to copy data and dispatch the arrays into domain objects, this has an impact on both memory and CPU usage. The only way to avoid this duplication is to perform the transformation at the problem level, i.e. to implement the problem as a first order one and then avoid using this class.

Since:
  1.2
Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 fÃ©vr. 2011) $
See Also:
  `FirstOrderIntegrator`, `FirstOrderDifferentialEquations`, `SecondOrderDifferentialEquations`

Constructor Summary
`FirstOrderConverter(SecondOrderDifferentialEquations equations)` Simple constructor.

Method Summary
`void` | `computeDerivatives(double t, double[] y, double[] yDot)` Get the current time derivative of the state vector.
`int` | `getDimension()` Get the dimension of the problem.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FirstOrderConverter

    public FirstOrderConverter(SecondOrderDifferentialEquations equations)

  Simple constructor. Build a converter around a second order equations set.

  Parameters:
    `equations` - second order equations set to convert

Method Detail

### getDimension

    public int getDimension()

  Get the dimension of the problem.

  The dimension of the first order problem is twice the dimension of the underlying second order problem.

  Specified by:
    `getDimension` in interface `FirstOrderDifferentialEquations`
  Returns:
    dimension of the problem

### computeDerivatives

    public void computeDerivatives(double t,
                                   double[] y,
                                   double[] yDot)
                            throws DerivativeException

  Get the current time derivative of the state vector.

  Specified by:
    `computeDerivatives` in interface `FirstOrderDifferentialEquations`
  Parameters:
    `t` - current value of the independent time variable
    `y` - array containing the current value of the state vector
    `yDot` - placeholder array where to put the time derivative of the state vector
  Throws:
    `DerivativeException` - this exception is propagated to the caller if the underlying user function triggers one

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2011 The Apache Software Foundation. All Rights Reserved.